//BrainStorm mkH

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.Toolkit;

class Start_GUI extends JFrame
{
	
	//Attribute
	JPanel content_pane = new JPanel();	
	JPanel upper = new JPanel();
	JPanel lower = new JPanel();	
	JButton ok = new JButton("OK");
	Toolkit toolkit1 = Toolkit.getDefaultToolkit();
	Image image1 = toolkit1.getImage("hintergrund.jpg");
	ActionListener ok_listener = new OKButtonsListener();
	MyCanvas bild = new MyCanvas();
	
	//Methode: MAIN
	public static void main(String[] args)
	{
		Start_GUI test = new Start_GUI();
		test.setVisible(true);
	}
	
	//GUI
	public Start_GUI()
	{
		enableEvents(AWTEvent.WINDOW_EVENT_MASK);
		try
		{
			init();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
	
	private void init()
	{
		this.setContentPane(content_pane);
		this.setSize(new Dimension(605,455));
		this.setTitle("BrainStorm mkH `s UML-TOPP");
		this.setIconImage((new ImageIcon("brain.jpg")).getImage());
		
		bild.setSize(new Dimension(600,400));
		bild.setBackground(new Color(255, 255, 255));
		
		upper.setLayout(new BorderLayout());
		upper.add(bild, BorderLayout.WEST);
		
		lower.setLayout(new BorderLayout());	
		lower.add(ok, BorderLayout.CENTER);
		
		content_pane.setLayout(new BorderLayout());
		content_pane.add(upper,BorderLayout.NORTH);
		content_pane.add(lower,BorderLayout.SOUTH);
		
		ok.addActionListener(ok_listener); 
	}
	
	class OKButtonsListener implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			if (e.getActionCommand()=="OK")
			{
				dispose();
				UMLTOPP umltopp=new UMLTOPP();
				umltopp.start();		
			}
		}
	}
	
	//Canvas
	public class MyCanvas extends Canvas
	{
		MyCanvas()
		{
			setBackground(Color.white);
			setForeground(Color.black);
		}
		public void paint(Graphics g)
		{
			g.drawImage(image1, 5, 5, this);
		}
	}	
}
