//BrainStorm mkH

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.filechooser.*;
import java.io.*;

class UMLTOPP
{
	
	//Attribute
	static boolean klasse_offen=false;
	static boolean objekt_offen=false;
	static boolean usecase_offen=false;
	static boolean verbindung_offen=false;
	static boolean ph_offen=false;
	
	//Methode: Programm starten
	public void start()//Starte unser UMLTOPP
	{
		Gui_UMLTOPP gui_umltopp = new Gui_UMLTOPP();
		gui_umltopp.setVisible(true);
	}
	
	//GUI
	private class Gui_UMLTOPP extends JFrame //Startfenster von UMLTOPP
	{
		JPanel contentPane = new JPanel();
		
		JMenuBar jmenuBar1 = new JMenuBar();
		
		JMenu jmenu1 = new JMenu();
		JMenu jmenu2 = new JMenu();
		JMenu jmenu3 = new JMenu();
		JMenu jmenu4 = new JMenu();
		JMenu jmenu5 = new JMenu();
		
		JMenuItem jmenuItem1 = new JMenuItem();
		JMenuItem jmenuItem2 = new JMenuItem();
		JMenuItem jmenuItem3 = new JMenuItem();
		JMenuItem jmenuItem4 = new JMenuItem();
		JMenuItem jmenuItem5 = new JMenuItem();
		JMenuItem jmenuItem6 = new JMenuItem();
		JMenuItem jmenuItem7 = new JMenuItem();
		JMenuItem jmenuItem8 = new JMenuItem();
		JMenuItem jmenuItem9 = new JMenuItem();
		JMenuItem jmenuItem10 = new JMenuItem();
		
		Canvas my_canvas = new Canvas();
		JLayeredPane layered_pane = new JLayeredPane();
		
		ActionListener my_use_case_listener = new NeuUseCaseListener();
		ActionListener my_use_case_open = new OpenUseCaseListener();
		
		ActionListener my_klasse_listener = new NeuKlasseListener();
		ActionListener my_klasse_open = new OpenKlasseListener();
		
		ActionListener my_objekt_listener = new NeuObjektListener();
		ActionListener my_objekt_open = new OpenObjektListener();
		
		ActionListener my_verbindungen_listener = new NeuVerbindungenListener();
		ActionListener my_verbindungen_open = new OpenVerbindungListener();
		
		ActionListener my_pflichtenheft_listener = new NeuPflichtenheftListener();
		ActionListener my_pflichtenheft_open = new OpenPflichtenheftListener();
		
		final JFileChooser fc = new JFileChooser();
		
		//Construct the frame
		public Gui_UMLTOPP()
		{
			enableEvents(AWTEvent.WINDOW_EVENT_MASK);
			try
			{
				init();
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
		}
		
		//Component initialization von UMLTOPP_GUI
		public void init()
		{
			
			this.setLayeredPane(layered_pane);
			this.setContentPane(contentPane);
			this.setJMenuBar(jmenuBar1);
			this.setSize(new Dimension(600,600));
			this.setTitle("UML-Case-Tool by BrainStorm mkH");
			this.setIconImage((new ImageIcon("uml.jpg")).getImage());
			
			jmenu1.setText("Use-Case");
			jmenu2.setText("Klasse");
			jmenu3.setText("Objekt");
			jmenu4.setText("Verbindung");
			jmenu5.setText("Pflichtenheft");
			
			jmenuBar1.add(jmenu1);
			jmenuBar1.add(jmenu2);
			jmenuBar1.add(jmenu3);
			jmenuBar1.add(jmenu4);
			jmenuBar1.add(jmenu5);
			
			jmenuItem1.setText("Neu");
			jmenuItem2.setText("ffnen");
			jmenuItem3.setText("Neu");
			jmenuItem4.setText("ffnen");
			jmenuItem5.setText("Neu");
			jmenuItem6.setText("ffnen");
			jmenuItem7.setText("Neu");
			jmenuItem8.setText("ffnen");
			jmenuItem9.setText("Neu");
			jmenuItem10.setText("ffnen");
			
			jmenu1.add(jmenuItem1);
			jmenu1.add(jmenuItem2);
			jmenu2.add(jmenuItem3);
			jmenu2.add(jmenuItem4);
			jmenu3.add(jmenuItem5);
			jmenu3.add(jmenuItem6);
			jmenu4.add(jmenuItem7);
			jmenu4.add(jmenuItem8);
			jmenu5.add(jmenuItem9);
			jmenu5.add(jmenuItem10);
			
			jmenuItem1.addActionListener(my_use_case_listener);
			jmenuItem2.addActionListener(my_use_case_open);
			jmenuItem3.addActionListener(my_klasse_listener);
			jmenuItem4.addActionListener(my_klasse_open);
			jmenuItem5.addActionListener(my_objekt_listener);
			jmenuItem6.addActionListener(my_objekt_open);
			jmenuItem7.addActionListener(my_verbindungen_listener);
			jmenuItem8.addActionListener(my_verbindungen_open);
			jmenuItem9.addActionListener(my_pflichtenheft_listener);
			jmenuItem10.addActionListener(my_pflichtenheft_open);
			
			my_canvas.setBackground(new Color(255, 255, 255));
			my_canvas.setSize(new Dimension(600,550));
		}
		
		public class NeuUseCaseListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if(usecase_offen==false)
				{
					UseCase my_usecase=new UseCase();
					usecase_offen=true;
					my_usecase.edit();
				}
				else
				{
					;//wenn ein Usecaseeditierfenster schon offen, dann mache nichts
				}
			}
		}
		
		public class OpenUseCaseListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if(usecase_offen==false)
				{
					int returnVal =fc.showOpenDialog(Gui_UMLTOPP.this);
					if(returnVal == JFileChooser.APPROVE_OPTION)
					{
						try
						{
							File file = fc.getSelectedFile();
							UseCase my_usecase=new UseCase();
							my_usecase.load(file);
							usecase_offen=true;
						}
						catch(Exception f)
						{
							JOptionPane test = new JOptionPane();
							test.showMessageDialog(getParent(), f.getMessage(),"Fehlermeldung",JOptionPane.ERROR_MESSAGE);
						}
					}
				}
			}
		}
		
		
		public class NeuKlasseListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if (klasse_offen==false)
				{
					Klasse my_klasse=new Klasse();
					klasse_offen=true;
					my_klasse.edit();
				}
				else
				{
					;//wenn ein Klasseneditierfenster schon offen, dann mache nichts
				}
			}
		}
		
		public class OpenKlasseListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if(klasse_offen==false)
				{
					int returnVal =fc.showOpenDialog(Gui_UMLTOPP.this);
					if(returnVal == JFileChooser.APPROVE_OPTION)
					{
						try
						{
							File file = fc.getSelectedFile();
							Klasse my_klasse=new Klasse();							
							my_klasse.load(file);
							klasse_offen=true;
						}
						catch(Exception f)
						{
							JOptionPane test = new JOptionPane();
							test.showMessageDialog(getParent(), f.getMessage(),"Fehlermeldung",JOptionPane.ERROR_MESSAGE);
						}
					}
				}
			}
		}
		
		public class NeuObjektListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if(objekt_offen==false)
				{
					Objekt my_objekt = new Objekt();
					objekt_offen=true;
					my_objekt.edit();
				}
				else
				{
					;//wenn ein Objekteditierfenster schon offen, dann mache nichts
				}
			}
		}
		
		public class OpenObjektListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e) 
			{
				if(objekt_offen==false)
				{
					int returnVal =fc.showOpenDialog(Gui_UMLTOPP.this);
					if(returnVal == JFileChooser.APPROVE_OPTION)
					{
						File file = fc.getSelectedFile();
						try
						{														
							Objekt my_objekt=new Objekt();							
							my_objekt.load(file);						
							objekt_offen=true;						
						}
						catch (Exception f)
						{
							JOptionPane test = new JOptionPane();
							test.showMessageDialog(getParent(), f.getMessage(),"Fehlermeldung",JOptionPane.ERROR_MESSAGE);
						}
					}
				}
			}
		}
		
		
		public class NeuVerbindungenListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if(verbindung_offen==false)
				{
					Verbindung my_verbindung = new Verbindung();
					verbindung_offen=true;
					my_verbindung.edit();
				}
				else
				{
					;//wenn ein Verbindungeditierfenster schon offen, dann mache nichts
				}
			}
		}
		
		public class OpenVerbindungListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if(verbindung_offen==false)
				{
					int returnVal =fc.showOpenDialog(Gui_UMLTOPP.this);
					if(returnVal == JFileChooser.APPROVE_OPTION)
					{
						try
						{
							File file = fc.getSelectedFile();
							Verbindung my_verbindung=new Verbindung();							
							my_verbindung.load(file);
							verbindung_offen=true;
						}
						catch(Exception f)
						{
							JOptionPane test = new JOptionPane();
							test.showMessageDialog(getParent(), f.getMessage(),"Fehlermeldung",JOptionPane.ERROR_MESSAGE);
						}
					}
				}
			}
		}
		
		
		public class NeuPflichtenheftListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if(ph_offen==false)
				{
					Pflichtenheft my_pflichtenheft=new Pflichtenheft();
					ph_offen=true;
					my_pflichtenheft.edit();
				}
				else
				{
					;//wenn ein Pflichtenhefteditierfenster schon offen, dann mache nichts
				}
			}
		}
		
		public class OpenPflichtenheftListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if(ph_offen==false)
				{
					int returnVal =fc.showOpenDialog(Gui_UMLTOPP.this);
					if(returnVal == JFileChooser.APPROVE_OPTION)
					{
						try
						{
							File file = fc.getSelectedFile();
							Pflichtenheft my_ph=new Pflichtenheft();							
							my_ph.load(file);
							ph_offen=true;
						}
						catch(Exception f)
						{
							JOptionPane test = new JOptionPane();
							test.showMessageDialog(getParent(), f.getMessage(),"Fehlermeldung",JOptionPane.ERROR_MESSAGE);
						}
					}
				}
			}
		}
		
		//Overridden so we can exit when window is closed
		protected void processWindowEvent(WindowEvent e)
		{
			super.processWindowEvent(e);
			if (e.getID() == WindowEvent.WINDOW_CLOSING)
			{
				System.exit(0);
			}
		}
	}
}

