//BrainStorm mkH

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;
import java.lang.Math;
import java.util.*;
import java.io.*;

class Klasse
{
	
	//Attribute
	static boolean klasse_info_offen;
	Info   klasse_info;
	String klasse_stereotyp;
	String klasse_eigenschaftswerte;
	Vector klasse_attribute;
	Vector klasse_methoden;
	
	//Konstruktor
	Klasse()
	{
		klasse_info_offen=false;
		klasse_info=new Info();
		klasse_stereotyp="";
		klasse_eigenschaftswerte="";
		klasse_attribute=new Vector(1,1);//Vektor mit Platz fr ein Element, wchst um 1 Element wenn ntig
		klasse_methoden=new Vector(1,1);
	}
	
	//Methode: editieren
	public void edit()
	{
		Gui_Klasse my_klasse_gui = new Gui_Klasse();
		my_klasse_gui.setVisible(true);
		my_klasse_gui.pack();
	}
	
	//Methode: save
	public void save(File filename) throws Exception
	{
		XML xmlklasse =new XML();
		{
			xmlklasse.writeTag("klasse",0);
			xmlklasse.writeChar("\n");
			
			klasse_info.write(xmlklasse);
			
			xmlklasse.writeTag("body",2);
			xmlklasse.writeChar("\n");
			
			xmlklasse.writeTag("stereotyp",4);
			xmlklasse.writeString(klasse_stereotyp);
			xmlklasse.writeTag("/stereotyp",0);
			xmlklasse.writeChar("\n");
			
			xmlklasse.writeTag("eigenschaftswerte",4);
			xmlklasse.writeString(klasse_eigenschaftswerte);
			xmlklasse.writeTag("/eigenschaftswerte",0);
			xmlklasse.writeChar("\n");
			
			for(int count=0;count<klasse_attribute.size();count++)
			{
				xmlklasse.writeTag("attribute",4);
				xmlklasse.writeChar("\n");
				
				xmlklasse.writeTag("name",6);
				xmlklasse.writeString(((Attribut)klasse_attribute.get(count)).attribut_name);
				xmlklasse.writeTag("/name",0);
				xmlklasse.writeChar("\n");
				
				xmlklasse.writeTag("gueltigkeit",6);
				xmlklasse.writeString(((Attribut)klasse_attribute.get(count)).attribut_gueltigkeit);
				xmlklasse.writeTag("/gueltigkeit",0);
				xmlklasse.writeChar("\n");
				
				xmlklasse.writeTag("datentyp",6);
				xmlklasse.writeString(((Attribut)klasse_attribute.get(count)).attribut_datentyp);
				xmlklasse.writeTag("/datentyp",0);
				xmlklasse.writeChar("\n");
				
				xmlklasse.writeTag("wert",6);
				xmlklasse.writeString(((Attribut)klasse_attribute.get(count)).attribut_initialwert);
				xmlklasse.writeTag("/wert",0);
				xmlklasse.writeChar("\n");
				
				xmlklasse.writeTag("zusicherung",6);
				xmlklasse.writeString(((Attribut)klasse_attribute.get(count)).attribut_zusicherung);
				xmlklasse.writeTag("/zusicherung",0);
				xmlklasse.writeChar("\n");
				
				xmlklasse.writeTag("/attribute",4);
				xmlklasse.writeChar("\n");
			}
			for(int count=0;count<klasse_methoden.size();count++)
			{
				xmlklasse.writeTag("methode",4);
				xmlklasse.writeChar("\n");
				
				xmlklasse.writeTag("name",6);
				xmlklasse.writeString(((Methode)klasse_methoden.get(count)).methode_name);
				xmlklasse.writeTag("/name",0);
				xmlklasse.writeChar("\n");
				
				xmlklasse.writeTag("gueltigkeit",6);
				xmlklasse.writeString(((Methode)klasse_methoden.get(count)).methode_gueltigkeit);
				xmlklasse.writeTag("/gueltigkeit",0);
				xmlklasse.writeChar("\n");
				
				xmlklasse.writeTag("rueckgabetyp",6);
				xmlklasse.writeString(((Methode)klasse_methoden.get(count)).methode_rueckgabetyp);
				xmlklasse.writeTag("/rueckgabetyp",0);
				xmlklasse.writeChar("\n");
				
				
				xmlklasse.writeTag("parameter",6);
				xmlklasse.writeString(((Methode)klasse_methoden.get(count)).methode_parameter);
				xmlklasse.writeTag("/parameter",0);
				xmlklasse.writeChar("\n");
				
				xmlklasse.writeTag("zusicherung",6);
				xmlklasse.writeString(((Methode)klasse_methoden.get(count)).methode_zusicherung);
				xmlklasse.writeTag("/zusicherung",0);
				xmlklasse.writeChar("\n");
				
				xmlklasse.writeTag("/methode",4);
				xmlklasse.writeChar("\n");
			}
			xmlklasse.writeTag("/body",2);
			xmlklasse.writeChar("\n");
			xmlklasse.writeTag("/klasse",0);
			xmlklasse.writeChar("\n");
			xmlklasse.saveXml(filename);
		}
	}
	//Methode: laden
	public void load(File filename) throws Exception
	{
		XML  	xmlklasse=new XML();
		String  tag="";
		String  maname="";
		String  magueltigkeit="";
		String  matyp="";
		String  mawert="";
		String  mazusicherung="";
		
		klasse_info.filename=filename.getPath();
		
		xmlklasse.loadXml(filename);//XML Datei komplett in den Dateipuffer lesen
		tag=xmlklasse.getTag();		 //hole erstes Tag aus dem Buffer
		if (!tag.equals("klasse"))  //wenn das nicht <klasse> ist dann ist das auch keine klasseXMLDatei
		{
			System.out.println("Tag ist "+tag+"!=klasse, also");
			System.out.println("Diese Datei enthaelt keine klasse");
			System.exit(1);
		}
		
		while(!tag.equals("/klasse"))
		{
			tag=xmlklasse.getTag();
			if (tag.equals("header"))
			{
				klasse_info.read(xmlklasse);
			}
			else
			{
				if (tag.equals("body"))
				{
					while (!tag.equals("/body"))
					{
						tag=xmlklasse.getTag();
						if (tag.equals("stereotyp"))
						{
							klasse_stereotyp=xmlklasse.getString("stereotyp");
						}
						else
						{
							if (tag.equals("eigenschaftswerte"))
							{
								klasse_eigenschaftswerte=xmlklasse.getString("eigenschaftswerte");
							}
							else
							{
								if (tag.equals("attribute"))
								{
									while(!tag.equals("/attribute"))
									{
										tag=xmlklasse.getTag();
										if (tag.equals("name"))
										{
											maname=xmlklasse.getString("name");
										}
										else
										{
											if (tag.equals("gueltigkeit"))
											{
												magueltigkeit=xmlklasse.getString("gueltigkeit");
											}
											else
											{
												if (tag.equals("datentyp"))
												{
													matyp=xmlklasse.getString("datentyp");
												}
												else
												{
													if (tag.equals("wert"))
													{
														mawert=xmlklasse.getString("wert");
													}
													else
													{
														if (tag.equals("zusicherung"))
														{   mazusicherung=xmlklasse.getString("zusicherung");
														}
														else
														{
															if (!tag.equals("/attribute"))
															{   System.out.println("Tag ist "+tag+" also nichts bekanntes, also skipTag");
																xmlklasse.skipTag(tag);
															}
														}
													}
												}
											}
										}
									}  /*while(!tag.equals("/attribute"))*/
									
									Attribut aktuelles_Attribut=new Attribut();
									aktuelles_Attribut.attribut_name=maname;
									aktuelles_Attribut.attribut_gueltigkeit=magueltigkeit;
									aktuelles_Attribut.attribut_datentyp=matyp;
									aktuelles_Attribut.attribut_initialwert=mawert;
									aktuelles_Attribut.attribut_zusicherung=mazusicherung;
									klasse_attribute.addElement(aktuelles_Attribut);
								}
								else
								{
									if (tag.equals("methode"))
									{
										while(!tag.equals("/methode"))
										{
											tag=xmlklasse.getTag();
											if (tag.equals("name"))
											{
												maname=xmlklasse.getString("name");
											}
											else
											{
												if(tag.equals("gueltigkeit"))
												{
													magueltigkeit=xmlklasse.getString("gueltigkeit");
												}
												else
												{
													if (tag.equals("rueckgabetyp"))
													{
														matyp=xmlklasse.getString("rueckgabetyp");
													}
													else
													{
														if (tag.equals("parameter"))
														{
															mawert=xmlklasse.getString("parameter");
														}
														else
														{
															if (tag.equals("zusicherung"))
															{
																mazusicherung=xmlklasse.getString("zusicherung");
															}
															else
															{
																if (!tag.equals("/methode"))
																{
																	System.out.println("Tag ist "+tag+" also nichs bekanntes, also skipTag");
																	xmlklasse.skipTag(tag);
																}
															}
														}
													}
												}
											}
										}//while(!tag.equals("/methode"))
										Methode aktuelle_Methode=new Methode();
										aktuelle_Methode.methode_name=maname;
										aktuelle_Methode.methode_gueltigkeit=magueltigkeit;
										aktuelle_Methode.methode_rueckgabetyp=matyp;
										aktuelle_Methode.methode_parameter=mawert;
										aktuelle_Methode.methode_zusicherung=mazusicherung;
										klasse_methoden.addElement(aktuelle_Methode);
									} /*if (tag.equals("methode"))*/
									else
									{
										if (!tag.equals("/body"))
										{
											System.out.println("Tag ist "+tag+" also nichts was da sein knnte und auch nicht /body, also unbekannt, also skipTag");
											xmlklasse.skipTag(tag);
										}
									}
								} /* else von if (tag.equals("attribute"))*/
							}/* else if (tag.equals("eigenschaftswerte"))*/
						}/* else von if (tag.equals("stereotyp"))*/
					}/* while (!tag.equals("/body")) */
				} /*if tag.equals("body")*/
			} /*else wenns kein header ist*/
		} /*while(!tag.equals("/klasse"))*/
		this.edit();//rufe nun die EDIT-Methode von Klasse auf
	} /*load*/
	
	//Datentyp: Methode einer Klasse
	private class Methode
	{
		String methode_name;
		String methode_gueltigkeit;
		String methode_rueckgabetyp;
		String methode_parameter;
		String methode_zusicherung;
		
		Methode()
		{
			methode_name="";
			methode_gueltigkeit="";
			methode_rueckgabetyp="";
			methode_parameter="";
			methode_zusicherung="";
		}
	}
	
	//Datentyp: Attribut einer Klasse
	private class Attribut
	{
		String attribut_name;
		String attribut_gueltigkeit;
		String attribut_datentyp;
		String attribut_initialwert;
		String attribut_zusicherung;
		
		Attribut()
		{
			attribut_name="";
			attribut_gueltigkeit="";
			attribut_datentyp="";
			attribut_initialwert="";
			attribut_zusicherung="";
		}
	}
	
	//GUI
	class Gui_Klasse extends JFrame
	{
		final JFileChooser fc = new JFileChooser();
		
		JPanel content_pane = new JPanel();
		
		JPanel left = new JPanel();
		JPanel right = new JPanel();
		
		JPanel right_buttons = new JPanel();
		
		JPanel one1 = new JPanel();
		JPanel one11 = new JPanel();
		JPanel one2 = new JPanel();
		JPanel oneall = new JPanel();
		
		JPanel two1 = new JPanel();
		JPanel two2 = new JPanel();
		JPanel two21 = new JPanel();
		JPanel two22 = new JPanel();
		JPanel two3 = new JPanel();
		JPanel two31 = new JPanel();
		JPanel twoall = new JPanel();
		
		JPanel three1 = new JPanel();
		JPanel three2 = new JPanel();
		JPanel three21 = new JPanel();
		JPanel three22 = new JPanel();
		JPanel three3 = new JPanel();
		JPanel three31 = new JPanel();
		JPanel threeall = new JPanel();
		
		String klasse = "";
		String stereo = "";
		String eigen = "";
		
		JSplitPane my_splitter = new JSplitPane(1, left, right);
		
		Vector my_attributes = new Vector(1,1);//Vektor mit Platz fr 1 Element, wchst bei Bedarf um 1
		Vector my_methods = new Vector(1,1);
		JList attribute_list = new JList(my_attributes);
		JList method_list = new JList(my_methods);
		
		JScrollPane scroll_attributes = new JScrollPane(attribute_list);
		JScrollPane scroll_methods = new JScrollPane(method_list);
		
		//TextFields des Reiters "Allgemein"
		JTextField class_name = new JTextField(klasse_info.info_name,10);
		JTextField stereotyp = new JTextField(klasse_stereotyp,10);
		JTextField typvalue = new JTextField(klasse_eigenschaftswerte,25);
		
		//TextFields des Reiters "Attribute"
		JTextField attribute_name = new JTextField(10);
		JTextField datatyp = new JTextField(10);
		JTextField initial_value = new JTextField(25);
		JTextField attribute_assurance = new JTextField(25);
		
		//TextFields des Reiters "Methoden"
		JTextField method_name = new JTextField(10);
		JTextField returntyp = new JTextField(10);
		JTextField parameters = new JTextField(25);
		JTextField method_assurance = new JTextField(25);
		
		JButton info = new JButton("Info");
		JButton attribute_button1 = new JButton("Hinzufgen");
		JButton attribute_button2 = new JButton("Ersetzen");
		JButton attribute_button3 = new JButton("Lschen");
		
		JButton method_button1 = new JButton("Hinzufgen");
		JButton method_button2 = new JButton("Ersetzen");
		JButton method_button3 = new JButton("Lschen");
		
		JButton right_button1 = new JButton("Anzeigen");
		JButton right_button2 = new JButton("OK");
		JButton right_button3 = new JButton("Abbrechen");
		
		MyCanvas paint_canvas = new MyCanvas();
		
		JComboBox scope_attribute = new JComboBox();
		JComboBox scope_method = new JComboBox();
		JComboBox right_detail = new JComboBox();
		
		JTextArea text_area1 = new JTextArea(5, 15);
		
		ActionListener on_right_buttons = new RightButtonsListener();
		ActionListener on_methoden_buttons = new MethodenButtonsListener();
		ActionListener on_attribute_buttons = new AttributeButtonsListener();
		ListSelectionListener on_attribute_list_selections=new Attribute_ListSelectionListener();
		ListSelectionListener on_method_list_selections=new Methoden_ListSelectionListener();
		ActionListener on_right_detail = new RightDetailListener();
		
		//Construct the frame
		public Gui_Klasse()
		{
			enableEvents(AWTEvent.WINDOW_EVENT_MASK);
			try
			{
				init();
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
		}
		
		//Component initialization von Gui_Klasse
		private void init()
		{
			this.setContentPane(content_pane);
			this.setSize(new Dimension(900,500));
			this.setTitle("Klassen editieren");
			this.setIconImage((new ImageIcon("brain.jpg")).getImage());
			
			content_pane.add(my_splitter);
			
			left.setLayout(new BorderLayout());
			right.setLayout(new BorderLayout());
						
			right.setPreferredSize(new Dimension(500,500));
			
			paint_canvas.setSize(new Dimension(500,475));
			paint_canvas.setBackground(new Color(255, 255, 255));
			
			scroll_attributes.setPreferredSize(new Dimension(350, 60));
			scroll_methods.setPreferredSize(new Dimension(350, 60));
			
			scope_attribute.setBackground(new Color(255, 255, 255));
			scope_attribute.addItem("public");
			scope_attribute.addItem("protected");
			scope_attribute.addItem("private");
			scope_attribute.addItem("void");
			scope_attribute.addItem("abstract");
			
			scope_method.setBackground(new Color(255, 255, 255));
			scope_method.addItem("public");
			scope_method.addItem("protected");
			scope_method.addItem("private");
			scope_method.addItem("void");
			scope_method.addItem("abstract");
			
			right_detail.setBackground(new Color(255, 255, 255));
			right_detail.setToolTipText("Detailierungsgrad");
			right_detail.addItem("Alles");
			right_detail.addItem("Name+Attribute");
			right_detail.addItem("Name+Methoden");
			right_detail.addItem("Name");
			
			one1.setLayout(new BorderLayout());
			one1.add(info, BorderLayout.EAST);
			one1.add(one11, BorderLayout.WEST);
			
			one11.setLayout(new GridLayout(2,2));
			one11.add(new JLabel("Klassenname:"));
			one11.add(new JLabel("Stereotyp:"));
			one11.add(class_name);
			one11.add(stereotyp);
			
			one2.setLayout(new BorderLayout());
			one2.add(new JLabel("Eigenschaftswerte:"), BorderLayout.WEST);
			one2.add(typvalue, BorderLayout.EAST);
			
			oneall.setLayout(new BorderLayout());
			oneall.setBorder(new TitledBorder("Allgemein"));
			oneall.add(one1, BorderLayout.CENTER);
			oneall.add(one2, BorderLayout.SOUTH);
			
			two1.setLayout(new GridLayout(2,3));
			two1.add(new JLabel("Attributname:"));
			two1.add(new JLabel("Gltigkeitsbereich:"));
			two1.add(new JLabel("Datentyp:"));
			two1.add(attribute_name);
			two1.add(scope_attribute);
			two1.add(datatyp);
			
			two21.setLayout(new BorderLayout());
			two21.add(new JLabel("Initialwert:"), BorderLayout.WEST);
			two21.add(initial_value, BorderLayout.EAST);
			
			two22.setLayout(new BorderLayout());
			two22.add(new JLabel("Zusicherungen:"), BorderLayout.WEST);
			two22.add(attribute_assurance, BorderLayout.EAST);
			
			two2.setLayout(new BorderLayout());
			two2.add(two21, BorderLayout.NORTH);
			two2.add(two22, BorderLayout.CENTER);
			
			two31.setLayout(new GridLayout(0,3));
			two31.add(attribute_button1);
			two31.add(attribute_button2);
			two31.add(attribute_button3);
			
			two3.setLayout(new BorderLayout());
			two3.add(scroll_attributes, BorderLayout.NORTH);
			two3.add(two31, BorderLayout.SOUTH);
			
			twoall.setLayout(new BorderLayout());
			twoall.setBorder(new TitledBorder("Attribute"));
			twoall.add(two1, BorderLayout.NORTH);
			twoall.add(two2, BorderLayout.CENTER);
			twoall.add(two3, BorderLayout.SOUTH);
			
			three1.setLayout(new GridLayout(2,3));
			three1.add(new JLabel("Methodenname:"));
			three1.add(new JLabel("Gltigkeitsbereich:"));
			three1.add(new JLabel("Rckgabetyp:"));
			three1.add(method_name);
			three1.add(scope_method);
			three1.add(returntyp);
			
			three21.setLayout(new BorderLayout());
			three21.add(new JLabel("Parameter:"), BorderLayout.WEST);
			three21.add(parameters, BorderLayout.EAST);
			
			three22.setLayout(new BorderLayout());
			three22.add(new JLabel("Zusicherungen:"), BorderLayout.WEST);
			three22.add(method_assurance, BorderLayout.EAST);
			
			three2.setLayout(new BorderLayout());
			three2.add(three21, BorderLayout.NORTH);
			three2.add(three22, BorderLayout.CENTER);
			
			three31.setLayout(new GridLayout(0,3));
			three31.add(method_button1);
			three31.add(method_button2);
			three31.add(method_button3);
			
			three3.setLayout(new BorderLayout());
			three3.add(scroll_methods, BorderLayout.NORTH);
			three3.add(three31, BorderLayout.SOUTH);
			
			threeall.setLayout(new BorderLayout());
			threeall.setBorder(new TitledBorder("Methoden"));
			threeall.add(three1, BorderLayout.NORTH);
			threeall.add(three2, BorderLayout.CENTER);
			threeall.add(three3, BorderLayout.SOUTH);
			
			left.add(oneall, BorderLayout.NORTH);
			left.add(twoall, BorderLayout.CENTER);
			left.add(threeall, BorderLayout.SOUTH);
			
			right_buttons.setLayout(new GridLayout(0, 4));
			right_buttons.add(right_button1);
			right_buttons.add(right_detail);
			right_buttons.add(right_button2);
			right_buttons.add(right_button3);
			
			right.add(paint_canvas, BorderLayout.NORTH);
			right.add(right_buttons, BorderLayout.SOUTH);
			
			if(!(klasse_attribute.size()==0))
			{
				Attribut x=new Attribut();
				for(int i=0;i<klasse_attribute.size();i++)
				{
					x=(Attribut) klasse_attribute.get(i);
					my_attributes.addElement(x.attribut_gueltigkeit+" "+x.attribut_datentyp+" "+x.attribut_name+" "+
						x.attribut_initialwert+" {"+x.attribut_zusicherung+"}");
				}
				attribute_list.updateUI();
			}
			
			if(!(klasse_methoden.size()==0))
			{
				Methode x=new Methode();
				for(int i=0;i<klasse_methoden.size();i++)
				{
					x=(Methode) klasse_methoden.get(i);
					my_methods.addElement(x.methode_gueltigkeit+" "+x.methode_rueckgabetyp+" "+x.methode_name+
						"("+x.methode_parameter+") "+"{"+x.methode_zusicherung+"}");
				}
				method_list.updateUI();
			}
			//ButtonActionListeners
			info.addActionListener(on_right_buttons);
			right_button1.addActionListener(on_right_buttons);
			right_button2.addActionListener(on_right_buttons);
			right_button3.addActionListener(on_right_buttons);
			
			attribute_list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			attribute_list.addListSelectionListener(on_attribute_list_selections);
			method_list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			method_list.addListSelectionListener(on_method_list_selections);
			
			right_detail.addActionListener(on_right_detail);
			method_button1.addActionListener(on_methoden_buttons);
			method_button2.addActionListener(on_methoden_buttons);
			method_button3.addActionListener(on_methoden_buttons);
			attribute_button1.addActionListener(on_attribute_buttons);
			attribute_button2.addActionListener(on_attribute_buttons);
			attribute_button3.addActionListener(on_attribute_buttons);
		}
		
		class MethodenButtonsListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if (e.getActionCommand()=="Hinzufgen")
				{
					//zum AnzeigeVectorfrdieAttribute hinzufgen und list.update() ausfhren => anzeige
					my_methods.addElement(scope_method.getSelectedItem().toString()+
						" "+method_name.getText()+"("+parameters.getText()+ ":"+ returntyp.getText()+ ")"+
						" {"+method_assurance.getText()+"}");
					method_list.updateUI();
					
					//interne Speicherung der Attribute
					//Bem:pos von attribute_Vektor = pos von Anzeige_Vektor
					Methode aktuelle_Methode=new Methode();
					aktuelle_Methode.methode_name=method_name.getText();
					aktuelle_Methode.methode_gueltigkeit=scope_method.getSelectedItem().toString();
					aktuelle_Methode.methode_rueckgabetyp=returntyp.getText();
					aktuelle_Methode.methode_parameter=parameters.getText();
					aktuelle_Methode.methode_zusicherung=method_assurance.getText();
					klasse_methoden.addElement(aktuelle_Methode);
					
					//Textfields lschen,fr neue Eingabe
					method_name.setText("");
					returntyp.setText("");
					parameters.setText("");
					method_assurance.setText("");
					//Combobox Scope auf Initialwert=public setzen
					scope_method.setSelectedIndex(0);
				}
                                if (e.getActionCommand()=="Ersetzen")
				{
					if(!method_list.isSelectionEmpty())
					{       //interne Speicherung der Attribute
						//Bem:pos von attribute_Vektor = pos von Anzeige_Vektor
						Methode aktuelle_Methode=new Methode();
						aktuelle_Methode.methode_name=method_name.getText();
						aktuelle_Methode.methode_gueltigkeit=scope_method.getSelectedItem().toString();
						aktuelle_Methode.methode_rueckgabetyp=returntyp.getText();
						aktuelle_Methode.methode_parameter=parameters.getText();
						aktuelle_Methode.methode_zusicherung=method_assurance.getText();
						klasse_methoden.setElementAt(aktuelle_Methode,method_list.getSelectedIndex());

						//im Vector ersetzen und list.update() ausfhren => anzeige
						my_methods.setElementAt((scope_method.getSelectedItem().toString()+" "+
							" "+method_name.getText()+"("+parameters.getText()+ ":"+returntyp.getText()+")"+
							" {"+method_assurance.getText()+"}"),method_list.getSelectedIndex());
						method_list.updateUI();
						method_list.clearSelection();



						//Textfields lschen,fr neue Eingabe
						method_name.setText("");
						returntyp.setText("");
						parameters.setText("");
						method_assurance.setText("");
						//Combobox Scope auf Initialwert=public setzen
						scope_method.setSelectedIndex(0);
					}
                                        else
					{
						JOptionPane test = new JOptionPane();
						test.showMessageDialog(getParent(), "Markieren Sie zuerst die zu ersetzende Methode!");
					}
				}
				if (e.getActionCommand()=="Lschen")
				{
					if(!method_list.isSelectionEmpty())
					{
						klasse_methoden.removeElementAt(method_list.getSelectedIndex());//Vektor von Klasse "Klasse", er enthlt Attribut-Objekte
						klasse_methoden.trimToSize();
						my_methods.removeElementAt(method_list.getSelectedIndex());//Vektor von Klasse "Gui_Klasse", er enthlt Strings fr die Anzeige
						my_methods.trimToSize();
						//Textfields lschen,fr neue Eingabe
						method_name.setText("");
						returntyp.setText("");
						parameters.setText("");
						method_assurance.setText("");
						//Combobox Scope auf Initialwert=public setzen
						scope_method.setSelectedIndex(0);
						method_list.updateUI();
						method_list.clearSelection();
					}
                                        else
					{
						JOptionPane test = new JOptionPane();
						test.showMessageDialog(getParent(), "Bitte zu lschende Methode in der Liste markieren!");
					}
				}
			}
		}

		class AttributeButtonsListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if (e.getActionCommand()=="Hinzufgen")
				{
					//zum AnzeigeVectorfrdieAttribute hinzufgen und list.update() ausfhren => anzeige
					my_attributes.addElement(scope_attribute.getSelectedItem().toString()+" "+datatyp.getText()+
						" "+attribute_name.getText()+" = "+initial_value.getText()+
						" {"+attribute_assurance.getText()+"}");
					attribute_list.updateUI();

					//interne Speicherung der Attribute
					//Bem:pos von attribute_Vektor = pos von Anzeige_Vektor
					Attribut aktuelles_Attribut=new Attribut();
					aktuelles_Attribut.attribut_name=attribute_name.getText();
					aktuelles_Attribut.attribut_gueltigkeit=scope_attribute.getSelectedItem().toString();
					aktuelles_Attribut.attribut_datentyp=datatyp.getText();
					aktuelles_Attribut.attribut_initialwert=initial_value.getText();
					aktuelles_Attribut.attribut_zusicherung=attribute_assurance.getText();
					klasse_attribute.addElement(aktuelles_Attribut);

					//Textfields lschen,fr neue Eingabe
					attribute_name.setText("");
					datatyp.setText("");
					initial_value.setText("");
					attribute_assurance.setText("");
					//Combobox Scope auf Initialwert=public setzen
					scope_attribute.setSelectedIndex(0);
				}
                                if (e.getActionCommand()=="Ersetzen")
				{
					if(!attribute_list.isSelectionEmpty())
					{
						//interne Speicherung der Attribute
						//Bem:pos von attribute_Vektor = pos von Anzeige_Vektor
						Attribut aktuelles_Attribut=new Attribut();
						aktuelles_Attribut.attribut_name=attribute_name.getText();
						aktuelles_Attribut.attribut_gueltigkeit=scope_attribute.getSelectedItem().toString();
						aktuelles_Attribut.attribut_datentyp=datatyp.getText();
						aktuelles_Attribut.attribut_initialwert=initial_value.getText();
						aktuelles_Attribut.attribut_zusicherung=attribute_assurance.getText();
						klasse_attribute.setElementAt(aktuelles_Attribut,attribute_list.getSelectedIndex());

						//im Vector ersetzen und list.update() ausfhren => anzeige
						my_attributes.setElementAt((scope_attribute.getSelectedItem().toString()+" "+datatyp.getText()+
							" "+attribute_name.getText()+" = "+initial_value.getText()+
							" {"+attribute_assurance.getText()+"}"),attribute_list.getSelectedIndex());
						attribute_list.updateUI();
						attribute_list.clearSelection();



						//Textfields lschen,fr neue Eingabe
						attribute_name.setText("");
						datatyp.setText("");
						initial_value.setText("");
						attribute_assurance.setText("");
						//Combobox Scope auf Initialwert=public setzen
						scope_attribute.setSelectedIndex(0);
					}
                                        else
					{
						JOptionPane test = new JOptionPane();
						test.showMessageDialog(getParent(), "Markieren Sie zuerst das zu ersetzende Attribut!");
					}
				}

				if (e.getActionCommand()=="Lschen")//beim Aufrufen kommt ArrayIndexOUtOfBoundsException, wieso wei ich nicht, aber alles luft weiter...
				{
					if(!attribute_list.isSelectionEmpty())
					{
						klasse_attribute.removeElementAt(attribute_list.getSelectedIndex());//Vektor von Klasse "Klasse", er enthlt Attribut-Objekte
						klasse_attribute.trimToSize();
						my_attributes.removeElementAt(attribute_list.getSelectedIndex());//Vektor von Klasse "Gui_Klasse", er enthlt Strings fr die Anzeige
						my_attributes.trimToSize();
						//Textfields lschen,fr neue Eingabe
						attribute_name.setText("");
						datatyp.setText("");
						initial_value.setText("");
						attribute_assurance.setText("");
						//Combobox Scope auf Initialwert=public setzen
						scope_attribute.setSelectedIndex(0);
						attribute_list.updateUI();
						attribute_list.clearSelection();
					}
                                        else
					{
						JOptionPane test = new JOptionPane();
						test.showMessageDialog(getParent(), "Bitte zu lschendes Attribut in der Liste markieren!");
					}
				}
			}
		}
		
		public class Attribute_ListSelectionListener implements ListSelectionListener
		{
			public void valueChanged(ListSelectionEvent e)
			{
				if(attribute_list.getSelectedIndex()!=-1)
				{
					attribute_name.setText(((Attribut) klasse_attribute.get(attribute_list.getSelectedIndex())).attribut_name);
					datatyp.setText(((Attribut) klasse_attribute.get(attribute_list.getSelectedIndex())).attribut_datentyp);
					initial_value.setText(((Attribut) klasse_attribute.get(attribute_list.getSelectedIndex())).attribut_initialwert);
					attribute_assurance.setText(((Attribut) klasse_attribute.get(attribute_list.getSelectedIndex())).attribut_zusicherung);
					scope_attribute.setSelectedItem(((Attribut) klasse_attribute.get(attribute_list.getSelectedIndex())).attribut_gueltigkeit);
				}
			}
		}
		
		public class Methoden_ListSelectionListener implements ListSelectionListener
		{
			public void valueChanged(ListSelectionEvent e)
			{
				if(method_list.getSelectedIndex()!=-1)
				{
					method_name.setText(((Methode) klasse_methoden.get(method_list.getSelectedIndex())).methode_name);
					returntyp.setText(((Methode) klasse_methoden.get(method_list.getSelectedIndex())).methode_rueckgabetyp);
					parameters.setText(((Methode) klasse_methoden.get(method_list.getSelectedIndex())).methode_parameter);
					method_assurance.setText(((Methode) klasse_methoden.get(method_list.getSelectedIndex())).methode_zusicherung);
					scope_method.setSelectedItem(((Methode) klasse_methoden.get(method_list.getSelectedIndex())).methode_gueltigkeit);
				}
			}
		}
		
		public class RightDetailListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if(right_detail.getSelectedItem()=="Alles")
				{
					paint_canvas.repaint();
				}
				if(right_detail.getSelectedItem()=="Name+Attribute")
				{
					paint_canvas.repaint();
				}
				if(right_detail.getSelectedItem()=="Name+Methoden")
				{
					paint_canvas.repaint();
				}
				if(right_detail.getSelectedItem()=="Name")
				{
					paint_canvas.repaint();
				}
			}
		}
		
		
		public class RightButtonsListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if(e.getActionCommand()=="Info")
				{
					if (klasse_info_offen==false)
					{
						klasse_info.info_name=class_name.getText();
						klasse_info_offen=true;
						klasse_info.edit("Informationen der Klasse: "+klasse_info.info_name,"klasse");
						
					}
					else
					{;
					}
				}
				
                                if(e.getActionCommand()=="Anzeigen")
				{
                                        klasse = class_name.getText();
					stereo = stereotyp.getText();
					eigen = typvalue.getText();

                                        if(klasse.length() != 0)
                                        {
                                        	paint_canvas.repaint();
                                        }
                                        else
                                        {
						JOptionPane test = new JOptionPane();
						test.showMessageDialog(getParent(), "Bitte geben Sie einen Klassenname ein!");
					}
                                }
				
				if(e.getActionCommand()=="OK")
				{
					//interne Speicherung von Name,Stereo,Eigenschaftswerte
					//methoden und attribute werden ja schon durch hinzufgen bzw. ersetzen intern gespeichert
					klasse_info.info_name=class_name.getText();
					klasse_stereotyp=stereotyp.getText();
					klasse_eigenschaftswerte=typvalue.getText();
					
					fc.setDialogTitle("Klasse speichern");
					File default_file=new File(klasse_info.filename);
					fc.setSelectedFile(default_file);
					int returnVal =fc.showSaveDialog(Gui_Klasse.this);
					if(returnVal == JFileChooser.APPROVE_OPTION)
					{
						try
						{
							File file = fc.getSelectedFile();
							save(file);
							UMLTOPP.klasse_offen=false;							
							dispose();
						}
						catch(Exception f)
						{
							JOptionPane test = new JOptionPane();
							test.showMessageDialog(getParent(), f.getMessage(),"Fehlermeldung",JOptionPane.ERROR_MESSAGE);
						}
						
					}
				}
				
				if(e.getActionCommand()=="Abbrechen")
                                {
                                	Object[] test = { "OK", "CANCEL" };
                                        JOptionPane jop = new JOptionPane();
                                        int inputvalue = jop.showOptionDialog(null, "Abbrechen ohne zu speichern? Daten knnen verloren gehen!", "Warning",
              				JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE, null, test, test[0]);

                                        if(inputvalue == 0)
                                        {
                                        	UMLTOPP.klasse_offen=false;
						dispose();
                                        }
				}

			}
		}


		//Overridden so we can exit when window is closed
		protected void processWindowEvent(WindowEvent e)
		{
			super.processWindowEvent(e);
			if (e.getID() == WindowEvent.WINDOW_CLOSING)
			{
				UMLTOPP.klasse_offen=false;
				this.dispose();
			}
		}
		
		//Vorschaufenster
		public class MyCanvas extends Canvas
		{
			int maxattribut;
			int maxmethode;
			
			MyCanvas()
			{
				setBackground(Color.white);
				setForeground(Color.black);
			}
			public void paint(Graphics g)
			{
				if(klasse.length() > 0)
				{
					//WENN DER DETAILLIERUNGSGRAD NAME GEWHLT IST
					if(right_detail.getSelectedItem()=="Name")
					{
						int maxklasse=this.getFontMetrics(this.getFont()).stringWidth(klasse);
						int maxstereo;
						if(stereo.length()>0){maxstereo=this.getFontMetrics(this.getFont()).stringWidth("<<"+stereo+">>");}
						else{maxstereo=0;}
						int maxeigen;
						if(eigen.length()>0){maxeigen=this.getFontMetrics(this.getFont()).stringWidth("{"+eigen+"}");}
						else{maxeigen=0;}
						int maximum1=Math.max((Math.max(maxklasse,maxstereo)),maxeigen);
						
						g.drawRect(50,50,maximum1+10,55);
						g.drawString(klasse,55,80);
						if(stereo.length() > 0)
						{
							g.drawString("<<"+stereo+">>",55,65);
						}
						
						if(eigen.length() > 0)
						{
							g.drawString("{"+eigen+"}",55,95);
						}
					}
					//WENN DER DETAILLIERUNGSGRAD NAME+ATTRIBUTE GEWHLT IST
					
					if((klasse_attribute.isEmpty()==false)&&
						(right_detail.getSelectedItem()=="Name+Attribute"))
					{
						//Berechnet die maximale Lnge des obersten Abscnitts der Klasse
						int maxklasse=this.getFontMetrics(this.getFont()).stringWidth(klasse);
						int maxstereo;
						if(stereo.length()>0){maxstereo=this.getFontMetrics(this.getFont()).stringWidth("<<"+stereo+">>");}
						else{maxstereo=0;}
						int maxeigen;
						if(eigen.length()>0){maxeigen=this.getFontMetrics(this.getFont()).stringWidth("{"+eigen+"}");}
						else{maxeigen=0;}
						int maxname=Math.max((Math.max(maxklasse,maxstereo)),maxeigen);
						
						//Berechnet die maximale Lnge des Attributabschnitts
						
						int c=0;
						int test =0;
						for(int i=1;i<=klasse_attribute.size();i++)
						{
							maxattribut=Math.max(this.getFontMetrics(this.getFont()).stringWidth( (( (Attribut) klasse_attribute.get(c)).attribut_gueltigkeit)+ " "+
								(( (Attribut)klasse_attribute.get(c)).attribut_datentyp)+ " " +(( (Attribut)klasse_attribute.get(c)).attribut_name)+ " = " +
								(( (Attribut)klasse_attribute.get(c)).attribut_initialwert)+ " { " +(( (Attribut)klasse_attribute.get(c)).attribut_zusicherung) +" } "),test);
							test=maxattribut;
							c++;
							
						}
						
						//Berechnet, ob die Attribute oder die Namen lnger sind!
						int maximum1 =Math.max(maxname,maxattribut);
						//zeichnet den oberen Teil mit Name etc.
						g.drawRect(50,50,maximum1+10,55);
						g.drawString(klasse,55,80);
						if(stereo.length() > 0)
						{
							g.drawString("<<"+stereo+">>",55,65);
						}
						
						if(eigen.length() > 0)
						{
							g.drawString("{"+eigen+"}",55,95);
						}
						
						//zeichnet den Attributteil
						int k=0;
						int x=0;
						for(int i=1;i<=klasse_attribute.size();i++)
						{
							g.drawRect(50,105,maximum1+10,(klasse_attribute.size()*15)+5);
							g.drawString(  (( (Attribut) klasse_attribute.get(k)).attribut_gueltigkeit)+ " " +
								(( (Attribut) klasse_attribute.get(k)).attribut_datentyp)+  " " +
								(( (Attribut) klasse_attribute.get(k)).attribut_name)+ " = " +
								(( (Attribut) klasse_attribute.get(k)).attribut_initialwert)+ " { " +
								(( (Attribut) klasse_attribute.get(k)).attribut_zusicherung)+" } ",55,120+x);
							k++;
							x=x+15;
						}
					}
					//WENN DER DETAILLIERUNGSGRAD NAME+METHODEN GEWHLT IST
					if((klasse_methoden.isEmpty()==false)&&
						(right_detail.getSelectedItem()=="Name+Methoden"))
					{
						//Berechnet die maximale Lnge des obersten Abscnitts der Klasse
						int maxklasse=this.getFontMetrics(this.getFont()).stringWidth(klasse);
						int maxstereo;
						if(stereo.length()>0){maxstereo=this.getFontMetrics(this.getFont()).stringWidth("<<"+stereo+">>");}
						else{maxstereo=0;}
						int maxeigen;
						if(eigen.length()>0){maxeigen=this.getFontMetrics(this.getFont()).stringWidth("{"+eigen+"}");}
						else{maxeigen=0;}
						int maxname=Math.max((Math.max(maxklasse,maxstereo)),maxeigen);
						//Berechnet die maximale Lnge des Methodenabschnitts
						int c=0;
						int test =0;
						for(int i=1;i<=klasse_methoden.size();i++)
						{
							maxmethode=Math.max(this.getFontMetrics(this.getFont()).stringWidth( (( (Methode) klasse_methoden.get(c)).methode_gueltigkeit)+ " "+
								(( (Methode)klasse_methoden.get(c)).methode_name)+ "(" +(( (Methode)klasse_methoden.get(c)).methode_parameter)+ ":" +
								(( (Methode)klasse_methoden.get(c)).methode_rueckgabetyp)+ ")"+" {" +(( (Methode)klasse_methoden.get(c)).methode_zusicherung) +" } "),test);
							test=maxmethode;
							c++;
						}
						//Berechnet, ob die Methoden oder die Namen lnger sind!
						int maximum2 =Math.max(maxname,maxmethode);
						//zeichnet den oberen Teil mit Name etc.
						g.drawRect(50,50,maximum2+10,55);
						g.drawString(klasse,55,80);
						if(stereo.length() > 0)
						{
							g.drawString("<<"+stereo+">>",55,65);
						}
						
						if(eigen.length() > 0)
						{
							g.drawString("{"+eigen+"}",55,95);
						}
						
						//zeichnet den Methodenteil
						int k=0;
						int x=0;
						for(int i=1;i<=klasse_methoden.size();i++)
						{
							g.drawRect(50,105,maximum2+10,(klasse_methoden.size()*15)+5);
							g.drawString(  (((Methode) klasse_methoden.get(k)).methode_gueltigkeit)+" "+
								(( (Methode) klasse_methoden.get(k)).methode_name)+"("+
								(( (Methode) klasse_methoden.get(k)).methode_parameter)+":"+
								(( (Methode) klasse_methoden.get(k)).methode_rueckgabetyp)+")" +" {"+
								(( (Methode) klasse_methoden.get(k)).methode_zusicherung)+"}",55,120+x);
							k++;
							x=x+15;
						}
					}
					//WENN DER DETAILLIERUNGSGRAD ALLES GEWHLT IST
					if(right_detail.getSelectedItem()=="Alles")
					{
						//Berechnet die maximale Lnge des obersten Abscnitts der Klasse
						int maxklasse=this.getFontMetrics(this.getFont()).stringWidth(klasse);
						int maxstereo;
						if(stereo.length()>0){maxstereo=this.getFontMetrics(this.getFont()).stringWidth("<<"+stereo+">>");}
						else{maxstereo=0;}
						int maxeigen;
						if(eigen.length()>0){maxeigen=this.getFontMetrics(this.getFont()).stringWidth("{"+eigen+"}");}
						else{maxeigen=0;}
						int maxname=Math.max((Math.max(maxklasse,maxstereo)),maxeigen);
						
						//Berechnet die maximale Lnge des Attributabschnitts
						if(klasse_attribute.isEmpty()==false)
						{
							int c=0;
							int test =0;
							for(int i=1;i<=klasse_attribute.size();i++)
							{
								maxattribut=Math.max(this.getFontMetrics(this.getFont()).stringWidth( (( (Attribut) klasse_attribute.get(c)).attribut_gueltigkeit)+ " "+
									(( (Attribut)klasse_attribute.get(c)).attribut_datentyp)+ " " +(( (Attribut)klasse_attribute.get(c)).attribut_name)+ " = " +
									(( (Attribut)klasse_attribute.get(c)).attribut_initialwert)+ " { " +(( (Attribut)klasse_attribute.get(c)).attribut_zusicherung) +" } "),test);
								test=maxattribut;
								c++;
							}
						}
						else{maxattribut=0;}
						//Berechnet die maximale Lnge des Methodenabschnitts
						if(klasse_methoden.isEmpty()==false)
						{
							int c=0;
							int test =0;
							for(int i=1;i<=klasse_methoden.size();i++)
							{
								maxmethode=Math.max(this.getFontMetrics(this.getFont()).stringWidth( (( (Methode) klasse_methoden.get(c)).methode_gueltigkeit)+ " "+
									(( (Methode)klasse_methoden.get(c)).methode_name)+ "(" +(( (Methode)klasse_methoden.get(c)).methode_parameter)+ ":" +
									(( (Methode)klasse_methoden.get(c)).methode_rueckgabetyp)+ ")"+" {" +(( (Methode)klasse_methoden.get(c)).methode_zusicherung) +" } "),test);
								test=maxmethode;
								c++;
							}
						}
						else{maxmethode=0;}
						//Berechnet, ob die Attribute oder die Namen lnger sind!
						int maximum3 =Math.max((Math.max(maxname,maxattribut)),maxmethode);
						//zeichnet den oberen Teil mit Name etc.
						g.drawRect(50,50,maximum3+10,55);
						g.drawString(klasse,55,80);
						if(stereo.length() > 0)
						{
							g.drawString("<<"+stereo+">>",55,65);
						}
						
						if(eigen.length() > 0)
						{
							g.drawString("{"+eigen+"}",55,95);
						}
						//zeichnet den Attributteil
						int k=0;
						int x=0;
						for(int i=1;i<=klasse_attribute.size();i++)
						{
							g.drawRect(50,105,maximum3+10,(klasse_attribute.size()*15)+5);
							g.drawString(  (( (Attribut) klasse_attribute.get(k)).attribut_gueltigkeit)+ " " +
								(( (Attribut) klasse_attribute.get(k)).attribut_datentyp)+  " " +
								(( (Attribut) klasse_attribute.get(k)).attribut_name)+ " = " +
								(( (Attribut) klasse_attribute.get(k)).attribut_initialwert)+ " { " +
								(( (Attribut) klasse_attribute.get(k)).attribut_zusicherung)+" } ",55,120+x);
							k++;
							x=x+15;
						}
						//zeichnet den Methodenteil
						int k2=0;
						int x2=0;
						for(int i=1;i<=klasse_methoden.size();i++)
						{
							g.drawRect(50,(klasse_attribute.size()*15)+110,maximum3+10,(klasse_methoden.size()*15)+5);
							g.drawString(  (((Methode) klasse_methoden.get(k2)).methode_gueltigkeit)+" "+
								(( (Methode) klasse_methoden.get(k2)).methode_name)+"("+
								(( (Methode) klasse_methoden.get(k2)).methode_parameter)+":"+
								(( (Methode) klasse_methoden.get(k2)).methode_rueckgabetyp)+")" +" {"+
								(( (Methode) klasse_methoden.get(k2)).methode_zusicherung)+"}",55,((klasse_attribute.size()*15)+5)+120+x2);
							k2++;
							x2=x2+15;
						}
					}
				}
			}
		} //MyCanvas ende
	}//Gui_Klasse.ENDE
}//Ende Klasse

